{% extends "admin/base_site.html" %}
{% load adminmedia i18n mptt_tags %}

{% block extrahead %}
{{ block.super }}
<link rel="stylesheet" type="text/css" href="{{MEDIA_URL}}admin/css/forms.css" />
<link rel="stylesheet" type="text/css" href="{{MEDIA_URL}}admin/css/artcode/sortables.css" />

<script src="{{MEDIA_URL}}js/jquery/ui/ui.droppable.js" type="text/javascript"></script>
<script src="{{MEDIA_URL}}js/jquery/jquery.sortableTree.js" type="text/javascript"></script>
<script src="{{MEDIA_URL}}js/jquery/ui/effects.core.js" type="text/javascript"></script>
<script src="{{MEDIA_URL}}js/jquery/ui/effects.highlight.js" type="text/javascript"></script>

<script type="text/javascript">
// <![CDATA[
$(function() {  
   
    $.widget('ui.sortableTreeview', {
        _init: function() {
            var self = this;
 
            this.element.sortableTree({
                items: this.options.sortOn,
                distance: this.options.distance,
                helper: this.options.helper,
                handle: this.options.handle,
                scroll: this.options.scroll,
                cssNamespace: 'treeview',
                appendTo: this.options.appendTo,
                revert: false,
                
                update: this.options.update,

                start: function(event, ui) {
                    var inst = $(this).data("sortableTree");
                    inst.placeholder.hide();
                    inst.helperProportions.height = inst.currentItem.find(self.options.dropOn).length ? inst.currentItem.find(self.options.dropOn).outerHeight() : inst.currentItem.outerHeight();
                    inst._preserveHelperProportions = true;
                    inst.refreshPositions(true);

                    self.originalParent = ui.item.parent();

                    (self.options.start && self.options.start.apply(this, [event, ui]));
                },

                stop: function(event, ui) {
                    var sortable = $(this).data("sortableTree");
                    $(sortable.options.items, sortable.element).removeClass(self.options.sortIndicatorDown).removeClass(self.options.sortIndicatorUp);

                    if ( self.originalParent.is(':empty') )
                        self.originalParent.remove();

                    (self.options.stop && self.options.stop.apply(this, [event, ui]));
                },


                sortIndicator: function(event, item, append, hardRefresh) {
                    if (self.overDroppable) return;
                    append ? append[0].appendChild(this.placeholder[0]) : item.item[0].parentNode.insertBefore(this.placeholder[0], (this.direction == 'down' ? item.item[0] : item.item[0].nextSibling));

                    $(this.options.items, this.element).removeClass(self.options.sortIndicatorDown).removeClass(self.options.sortIndicatorUp);
                    item.item.addClass(this.direction == "down" ? self.options.sortIndicatorDown : self.options.sortIndicatorUp);

                }

            });
            
            $(this.element).find(this.options.dropOn).droppable({
                accept: "li",
                hoverClass: "treeview-sortable-hover",
                tolerance: "pointer",
                over: function(event, ui) {
                    if ($(this).is(':not(:last-child)')) {
                        $(this).removeClass('treeview-sortable-hover');
                        return false;
                    }
                    $('.treeview-sortable-placeholder').hide();
                    $(self.options.sortOn, self.element).removeClass(self.options.sortIndicatorDown).removeClass(self.options.sortIndicatorUp);
                    self.overDroppable = true;    
                },
                out: function(event, ui) {
                    $('.treeview-sortable-placeholder').show();
                    self.overDroppable = false;
                },
                drop: function(e,ui) {
                    if (!self.overDroppable) return;

                    var $ul = $(this).parent().find("ul");
                    if(!$ul.length) var $ul = $("<ul></ul>").appendTo($(this).parent());

                    var $target = $(this).parent().find("> ul");
                    ui.draggable.appendTo($target);
                    self.element.data("sortableTree")._noFinalSort = true;
                }
            });
        
        }
    });

    $.extend($.ui.sortableTreeview, {
        defaults: {
            sortOn: "*",
            dropOn: "div",
            dropHoverClass: "treeview-sortable-hover",
            sortIndicatorDown: "hover-down",
            sortIndicatorUp: "hover-up",
            update: function(event, ui) {
                var $parent = ui.item.parents('li.container').slice(0,1);
                var $rght = ui.item.nextAll().not('.treeview-sortable-placeholder'); 
                var $lft = ui.item.prevAll().not('.treeview-sortable-placeholder');

                data = {
                    item: ui.item.attr('id').replace('item_','')
                }
                if ($parent.length) data['parent'] = $parent.attr('id').replace('item_','');
                if ($rght.length) data['rght'] = $rght.attr('id').replace('item_','');
                if ($lft.length) data['lft'] = $lft.attr('id').replace('item_','');
                $.post('{% url admin:menus_menuitem_move %}', data);
            }
        }
    });

    var $menu_ul = $('.menu-list > ul');
    var $list_item = $('<li class="leaf"><span class="page"><span class="tools"><a class="changelink">Edit</a> <a class="deletelink">Remove from menu</a></span><span class="move"></span><span class="title"></span></span></li>').hide();
    if (! $menu_ul.length) {
        $menu_ul = $('<ul class="tree-list filetree"></ul>').appendTo('.menu-list').append($list_item);

    } 

    // Create sortable Tree
    $menu_ul.sortableTreeview({
        sortOn: 'li',
        handle: 'span.page, span.app, span.folder',
        dropOn: '.container > span.folder',
        distance: 4,
        helper: function(e,item) {
            return $("<div class='treeview-sortable-helper'>"+item.find("span").html()+"</div>");
        }
    });

    // Adding new objects to the menuitem tree
    $('.unused-object input[type=checkbox]').click(function() {
        if (!this.checked) {
            return;
        }
        var $$ = $(this).parents('li.unused-object');
        var info = $$.attr('id').split('_');
        var model = info[0];
        var pk = info[1]
        var title = $$.attr('title');

        $.post('{% url admin:menus_menuitem_add_object %}', {
            pk: pk,
            model: model
        }, function(data) {
            var $newitem = $('.menu-list ul li.leaf').eq(0).clone();
            $newitem.attr('id', 'item_' + data.id).appendTo($menu_ul).show()
                .find('.title').text(data.item_title);
            $newitem.find('.tools .changelink').attr('href', data.id + '/edit_object/');
            $newitem.find('.tools .deletelink').attr('href', data.id + '/delete/');
            var $parent_list = $$.closest('ul');
            $$.remove();
            $parent_list.filter(':empty').closest('.module').fadeOut('slow');
            
            $menu_ul.sortableTreeview('refresh');
            $newitem.find('> span.page').effect('highlight', {color: '#659DC2'}, 'slow');
        }, 'json');
    });

    // Add new app to the menuitemtree
    $('.unused-app input[type=checkbox]').click(function() {
        if (!this.checked) {
            return;
        }
        var $input = $(this);
        var $$ = $input.parents('li.unused-app');
        var title = $$.attr('id').replace(/^app_/, '');
        var url = $$.attr('title');

        $.post('{% url admin:menus_menuitem_add_item %}', {
            title: title,
            url: url
        }, function(data) {
            var $newitem = $('.menu-list ul li.leaf').eq(0).clone();
            $newitem.attr('id', 'item_' + data.id).appendTo($menu_ul).show()
                .find('.title').text(data.item_title);
            $newitem.find('.tools .changelink').attr('href', data.id + '/');
            $newitem.find('.tools .deletelink').attr('href', data.id + '/delete/');
            
            var $parent_list = $$.closest('ul');
            $$.remove();
            $parent_list.filter(':empty').closest('.module').fadeOut('slow');
            $input.attr('checked', false);
            $menu_ul.sortableTreeview('refresh');
            $newitem.find('> span.page').effect('highlight', {color: '#659DC2'}, 500);
        }, 'json');
    });

    $('.menu-list .deletelink').live('click', function() {
        $.post(this.href, {
            post: 'yes'
        }, function() {
            window.location.reload();
        });
        return false;
    });

    // Add link form views
    $('.additions a.addlink + fieldset').prev().toggle(function() {
        $(this).next().slideDown();
    }, function() {
        $(this).next().hide();
    }).next().hide();

});
// ]]>
</script>
{% endblock %}

{% block breadcrumbs %}<div class="breadcrumbs"><a href="{% url admin:index %}">{% trans 'Home' %}</a> &rsaquo; Menus</div>{% endblock %}

{% block content %}
<div id="content-main" class="menus">
<h1>Menus</h1>
<p class="quiet">
    Here's where you can organize your site's menu layout. You can add and remove Pages and Apps <br/>
    from the menu, and sort your pages into categories. To move a a page, simply drag a menu item <br/>
    from one place in the list to another.
</p>
<br/>
<div class="related-module">
<div class="additions">
    <form action="" method="post">{% csrf_token %}
    <a class="addlink" href="#">Add a Category</a>
    <fieldset class="aligned">
        <label>Name: </label><input type="text" name="title" value="" /> <input type="submit" value="Add" />
    </fieldset>
    </form>

    <form action="" method="post">{% csrf_token %}
    <a class="addlink" href="#">Add an External Link</a>
    <fieldset class="aligned">
        <label>Name: </label><input type="text" name="title" value="" /><br/>
        <label>Url: </label><input type="text" name="url" value="http://" />
        <input type="submit" value="Add" />
    </fieldset>
    </form>
</div>

{% for model, objects, count in unused_objects %}
{% if objects %}
<div class="module">
    <h2>Available {{model.verbose_name_plural|capfirst}}</h2>
    {% spaceless %}
    <ul class="unused-objects {{model.module_name}}">
    {% for obj in objects %}
        <li id="{{model.app_label}}.{{model.object_name}}_{{obj.pk}}" class="unused-object" title="{{obj.title}}">
            <span class="tools">
                <label><input type="checkbox" /> add to menu</label>
            </span>
            {{obj}}
        </li>
    {% endfor %}
    </ul>
    {% endspaceless %}
</div>
{% endif %}
{% endfor %}

{% if unused_apps %}
<div class="module">
    <h2>Available Apps</h2>
    {% spaceless %}
    <ul class="unused-apps">
    {% for app in unused_apps %}
        <li id="app_{{app.name}}" class="unused-app" title="{{app.url}}">
            <span class="tools">
                <label><input type="checkbox" /> add to menu</label>
            </span>
            {{ app.name }}
        </li>
    {% endfor %}
    </ul>
    {% endspaceless %}
</div>
{% endif %}
</div>

{% spaceless %}
<div class="menu-list">
{% for menuitem,structure in menuitems|tree_info %}
    {% if structure.new_level %}
    <ul class="tree-list filetree">
    <li class="{{menuitem.is_container|yesno:"container,leaf"}}" id="item_{{menuitem.id}}">
    {% else %}
    </li><li class="{{menuitem.is_container|yesno:"container,leaf"}}" id="item_{{menuitem.id}}">
    {% endif %}
    <span class="{% if menuitem.is_container %}folder{% else %}{% if menuitem.is_page %}page{% else %}app{% endif %}{% endif %}">
        <span class="tools">
            <a href="{{menuitem.pk}}/edit_object/" class="changelink">Edit</a>
            <a href="{{menuitem.pk}}/delete/" class="deletelink">Remove from menu</a>
        </span> 
        <span class="move">&nbsp;</span>  <span class="title">{{ menuitem.title }} {% if menuitem.is_external_link %}<em class="quiet">(external link)</em>{% endif %}</span> &nbsp;     
    </span>
    {% for level in structure.closed_levels %}
    </li></ul>
    {% endfor %}
{% endfor %}
</div>
{% endspaceless %}
</div>
{% endblock %}

